<template>
  <div>
    <v-toolbar
      flat
      color="primary"
      class="py-4"
      height="auto"
    >
      <v-toolbar-title>
        <a
          href="/"
          :aria-label="$t('logo.aria-label')"
        >
          <img
            class="logo"
            src="/images/LogoOuestGo.svg"
            alt="OuestGo"
          >
        </a>
      </v-toolbar-title>

      <v-btn
        class="white--text title font-weight-bold text-none"
        rounded
        text
        :aria-label="$t('buttons.toolbox.aria-label')"
        :href="$t('buttons.toolbox.href')"
      >
        {{ $t('buttons.toolbox.label') }}
      </v-btn>

      <v-btn
        class="white--text title font-weight-bold text-none"
        rounded
        text
        :aria-label="$t('buttons.eec.aria-label')"
        :href="$t('buttons.eec.href')"
      >
        {{ $t('buttons.eec.label') }}
      </v-btn>
      
      <v-spacer />
      <!-- <accessibility /> -->
      <div
        v-if="user"
        class="hidden-sm-and-down"
      >
        <MMessageBtn :unread-message-number="unreadMessageNumber" />
        <MHeaderCommunities
          :user-id="user.id" 
        />
        <MHeaderProfile
          :avatar="user.avatars[0]"
          :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
        />
      </div>
      <v-toolbar-items
        v-else
        class="hidden-sm-and-down"
      >
        <v-btn
          text
          rounded
          :href="$t('buttons.signup.route')"
          class="white--text font-weight-bold"
        >
          {{ $t('buttons.signup.label') }}
        </v-btn>
        <v-btn
          rounded
          text
          :href="$t('buttons.logIn.route')"
          class="white--text font-weight-bold"
        >
          {{ $t('buttons.logIn.label') }}
        </v-btn>
      </v-toolbar-items>
      <v-btn
        v-if="user"
        rounded
        :href="$t('buttons.shareAnAd.route')"
        class="hidden-sm-and-down"
      >
        {{ $t('buttons.shareAnAd.label') }}
      </v-btn>
      <div @click="snackbar = true">
        <v-btn
          v-if="!user"
          rounded
          disabled
          class="hidden-sm-and-down"
        >
          {{ $t('buttons.shareAnAd.label') }}
        </v-btn>
      </div>
      <v-toolbar-items
        class="hidden-md-and-down"
      >
        <MHeaderLanguage
          text-class="white--text font-weight-bold"
          :languages="languages"
          :language="dlocale"
          @languageSelected="updateLanguage"
        />
      </v-toolbar-items>
      <v-snackbar
        v-if="!user"
        v-model="snackbar"
        color="info"
      >
        {{ $t('snackbar.needConnection') }}
        <v-btn
          color="info"
          icon
          elevation="0"
          @click="snackbar = false"
        >
          <v-icon
            color="primary"
          >
            mdi-close
          </v-icon>
        </v-btn>
      </v-snackbar>

      <!--Display menu when user is connected-->

      <v-menu
        v-if="user"
        bottom
        left
        z-index="9"
        dark
      >
        <template v-slot:activator="{ on }">
          <v-btn
            icon
            class="hidden-md-and-up"
            v-on="on"
          >
            <v-icon>mdi-menu</v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title>
              <MHeaderLanguage
                text-class="white--text font-weight-bold"
                :languages="languages"
                :language="dlocale"
                @languageSelected="updateLanguage"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderProfile
                :short-familly-name="user.shortFamilyName ? user.givenName+' '+user.shortFamilyName : '-'"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderCommunities
                :user-id="user.id"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :disabled="!user"
                :href="$t('buttons.shareAnAd.route')"
              >
                {{ $t('buttons.shareAnAd.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
      
      <!--Display menu when there is no connected user-->

      <v-menu
        v-else
        bottom
        left
        z-index="9"
      >
        <template v-slot:activator="{ on }">
          <v-btn
            icon
            :aria-label="$t('buttons.burger.aria-label')"
            class="hidden-md-and-up"
            v-on="on"
          >
            <v-icon>mdi-menu</v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :href="$t('buttons.messages.route')"
              >
                {{ $t('buttons.messages.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.signup.route')"
              >
                {{ $t('buttons.signup.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :href="$t('buttons.logIn.route')"
              >
                {{ $t('buttons.logIn.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :disabled="!user"
                :href="$t('buttons.shareAnAd.route')"
              >
                {{ $t('buttons.shareAnAd.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-toolbar>
    <GamificationNotifications :user-gamification-notifications="(user && user.gamificationNotifications) ? user.gamificationNotifications : null" />
    <GratuityNotifications :user-gratuity-notifications="(user && user.gratuityNotifications) ? user.gratuityNotifications : null" />
    <!-- legal guardian dialog -->
    <v-dialog
      v-if="user"
      v-model="activeLegalGuardianDialog"
      persistent
      max-width="900"
    >
      <v-card>
        <v-card-title
          class="text-h5 justify-center"
        >
          {{ $t('dialog.parentalConsent.title') }}
        </v-card-title>
        <v-card-text v-html="$t('dialog.parentalConsent.content',{'legalGuardianEmail':user.legalGuardianEmail})" />
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="secondary"
            primary
            rounded
            :href="this.$t('buttons.logOut.route')"
          >
            {{ $t('dialog.parentalConsent.buttonLabel') }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { merge, has } from "lodash";
import {messages_en, messages_fr, messages_eu} from "@translations/components/base/MHeader/";
import {messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/base/MHeader/";
import MHeaderProfile from "@clientComponents/base/MHeaderProfile.vue";
import MHeaderCommunities from "@clientComponents/base/MHeaderCommunities.vue";
import MHeaderLanguage from "@components/base/MHeaderLanguage.vue";
import MMessageBtn from "@components/base/MMessageBtn.vue";
import GamificationNotifications from "@components/utilities/gamification/GamificationNotifications";
import GratuityNotifications from "@components/utilities/gratuity/GratuityNotifications";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'eu': MessagesMergedEu,
      'fr': MessagesMergedFr
    }
  },
  components: {
    // Accessibility,
    MHeaderProfile,
    MHeaderCommunities,
    MHeaderLanguage,
    MMessageBtn,
    GamificationNotifications,
    GratuityNotifications
  },
  props: {
    user: {
      type: Object,
      default: null
    },
    urlMobile: {
      type: String,
      default: null
    },
    locale: {
      type: String,
      default: "fr"
    },
    languages: {
      type: Object,
      default: () => {}
    },
    token: {
      type: String,
      default: ''
    },
    gamificationActive:{
      type: Boolean,
      default: false
    }
  },
  data(){
    return{
      width: 0,
      defaultLocale: 'fr',
      dlocale: this.locale,
      snackbar: null,
      activeLegalGuardianDialog: false
    }
  },
  computed:{
    unreadMessageNumber(){
      return this.user.unreadCarpoolMessageNumber + this.user.unreadDirectMessageNumber + this.user.unreadSolidaryMessageNumber; 
    }
  },
  mounted() {
    if (has(this.languages, this.locale)) {
      this.dlocale = this.locale;
    } else {
      this.dlocale = this.defaultLocale;
    }
    this.$store.commit('g/setActive',this.gamificationActive);
    this.$store.commit('grt/setActive',this.gratuityActive);
  },
  created() {
    this.$store.commit('a/setToken',this.user?.token ? this.user.token : this.token);
    if(this.user){
      localStorage.setItem('X-LOCALE',this.dlocale);
    }
    if(this.user?.needParentalConsent) {
      this.activeLegalGuardianDialog = true;
    }
    this.$root.$i18n.locale = this.dlocale
  },
  methods:{
    updateLanguage(language) {
      this.$root.$i18n.locale = language
    },
  }
}
</script>